# Generated by Django 2.0.5 on 2020-01-13 05:33

from django.db import migrations


class Migration(migrations.Migration):

    def add_request_description_to_existing_docs_and_templates(apps, schema_editor):

        def _update_json_with_request_description(json_config):
            request_description = {
                "section_label": "Request Description Section",
                "ordering": 1,
                "label": "Request Description",
                "value": "",
                "type": "TEXTBOX",
                "input_type": "STRING",
                "is_label_editable": "false",
            }
            try:
                json_config["project_details"]["request_description"] = request_description
                json_config["project_details"]["task_deliverables"]["ordering"] = 2
                json_config["project_details"]["project_assumptions"]["ordering"] = 3
                json_config["project_details"]["out_of_scope"]["ordering"] = 4
            except KeyError:
                pass
            return json_config

        SOWDocument = apps.get_model("document", "SOWDocument")
        SOWTemplate = apps.get_model("document", "SOWTemplate")
        # Add Request Description field to all docs and templates and update ordering of subsequent fields
        for doc in SOWDocument.objects.all():
            json_config = _update_json_with_request_description(doc.json_config)
            doc.json_config = json_config
            doc.save()
        for template in SOWTemplate.objects.all():
            json_config = _update_json_with_request_description(template.json_config)
            template.json_config = json_config
            template.save()

    dependencies = [
        ('document', '0033_auto_20191127_1304'),
    ]

    operations = [
        migrations.RunPython(add_request_description_to_existing_docs_and_templates)
    ]
